using System;
namespace Takmicenje3B
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] doha = Console.ReadLine().Split(' ');
            int x = int.Parse(doha[0]);
            int y = int.Parse(doha[1]);

            long[,] brojnavijaca = new long[x, y];
            for (int i = 0; i < x; i++)
            {
                string[] unos = Console.ReadLine().Split(' ');
                for (int j = 0; j < y; j++)
                {
                    brojnavijaca[i, j] = long.Parse(unos[j]);
                }
            }

            

            int Q = int.Parse(Console.ReadLine());
            long[] rezultati = new long[Q];
            
            for (int t = 0; t < Q; t++)
            {
                string[] unos = Console.ReadLine().Split(' ');
                int xblok = int.Parse(unos[0]);
                int yblok = int.Parse(unos[1]);

                long suma = brojnavijaca[0, 0];
                int i = 0; int j = 1;
                while (i <= x - 1)
                {
                   
                    if ((i==xblok-1 && j==yblok-1) || (((i+1) == xblok - 1 && j == yblok - 1 && j==y-1)))
                    {
                        i++;
                        suma += brojnavijaca[i, j - 1];
                        continue;
                    }
                    if (((i + 1) == xblok - 1 && j-1 == yblok - 1))
                    {
                        suma += brojnavijaca[i, j];
                        if (j == y - 1)
                        {
                            i++;
                        }
                        else
                        {
                            j++;
                        }
                        continue;
                    }
                
                     
                        if ((j == y - 1) || (brojnavijaca[i, j] < brojnavijaca[i+1,j-1]))
                        {
                            suma += brojnavijaca[i, j];
                            if (j== y - 1)
                            {
                                i++;
                            }
                            else {
                                j++; 
                            }
                            
                        }
                        else
                        {
                            i++;
                            suma += brojnavijaca[i, j - 1];
                        }
                    

                }

                rezultati[t] = suma;
            }

            foreach (long rezultat in rezultati)
            {
                Console.WriteLine(rezultat);
            }
        }
    }
}